#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <windows.h>

//global variables
STARTUPINFO si;
PROCESS_INFORMATION pi;
char *uri; //contents of uri.dat
char *script; //contents of script.dat
unsigned int script_size; //sizeof(script) + 1
#include "pointer.h" //unsigned char pointer_list[pointer_list_size]

//library functions
void write_byte(DWORD addr, BYTE data);
void write_word(DWORD addr, USHORT data);
void write_dword(DWORD addr, DWORD data);
void write_string(DWORD addr, PSTR buffer);
void write_block(DWORD addr, PSTR buffer, DWORD size);
LPVOID allocate_memory(DWORD size);

/*****
 * apply_patches()
 * use this function to apply all startup patches to ShirenV2.exe
 *****/

void apply_patches() {
//Build URI strings from base uri
char uri_authori[128], uri_ranking[128], uri_rescue[128];
  strcpy(uri_authori, uri);
  strcpy(uri_ranking, uri);
  strcpy(uri_rescue, uri);
  strcat(uri_authori, "authori.php");
  strcat(uri_ranking, "ranking.php");
  strcat(uri_rescue, "rescue.php");

//Allocate URI strings in ShirenV2 process memory
DWORD addr_authori, addr_ranking, addr_rescue;
  addr_authori = (DWORD)allocate_memory(128);
  addr_ranking = (DWORD)allocate_memory(128);
  addr_rescue  = (DWORD)allocate_memory(128);

//Write URI strings in ShirenV2 process memory
  write_string(addr_authori, uri_authori);
  write_string(addr_ranking, uri_ranking);
  write_string(addr_rescue,  uri_rescue);

//Allocate script strings in ShirenV2 process memory
DWORD addr_script;
  addr_script = (DWORD)allocate_memory(script_size);

//Write script in ShirenV2 process memory
  write_block(addr_script, script, script_size);

//Update pointers to each script line in ShirenV2 process memory
  
	LPBYTE ptr = (LPBYTE)script;
	for ( int i = 0; i < pointer_list_size; i++ ) {
		//if ( i == 445 ) break;
		//if ( i == 1000 ) break;
	//Update pointer
		if ( *ptr < 0x81 || *ptr > 0x98 ) // Skip patching SJIS Japanese text to avoid bugs
			write_dword(0x400000 + *(((LPDWORD)pointer_list) + i), addr_script + (ptr - (LPBYTE)script));
	//Scan for next pointer
		while ( *ptr ) { ptr++; }
		while ( *ptr == 0 ) { ptr++; } //skip null terminator
	}

//Patch for authori.php location
  write_dword(0x4087d3, addr_authori);

//Patch for ranking.php locations
  write_dword(0x40da2d, addr_ranking);
  write_dword(0x40da41, addr_ranking);
  write_dword(0x40dfe2, addr_ranking);
  write_dword(0x40e3c3, addr_ranking);
  write_dword(0x4277e3, addr_ranking);
  write_dword(0x427c29, addr_ranking);
  write_dword(0x428186, addr_ranking);

//Patch for rescue.php locations
  write_dword(0x45bfd2, addr_rescue);
  write_dword(0x45c015, addr_rescue);

//Patch the dialog window for failed "auth" response
  write_byte(0x427971, 0xeb);

//Patch the dialog window for failed download.dat request
  write_word(0x427C32, 0xdb31);
}

void write_byte(DWORD addr, BYTE data) {
	SIZE_T size;
	VirtualProtectEx(pi.hProcess,(LPVOID)addr, 1, PAGE_EXECUTE_READWRITE, &size);
	WriteProcessMemory(pi.hProcess,(LPVOID)addr,(LPVOID)&data, 1, &size);
}

void write_word(DWORD addr, unsigned short data) {
	SIZE_T size;
	VirtualProtectEx(pi.hProcess,(LPVOID)addr, 2, PAGE_EXECUTE_READWRITE, &size);
	WriteProcessMemory(pi.hProcess,(LPVOID)addr,(LPVOID)&data, 2, &size);
}

void write_dword(DWORD addr, DWORD data) {
	SIZE_T size;
	VirtualProtectEx(pi.hProcess,(LPVOID)addr, 4, PAGE_EXECUTE_READWRITE, &size);
	WriteProcessMemory(pi.hProcess,(LPVOID)addr,(LPVOID)&data, 4, &size);
}

void write_string(DWORD addr, PSTR buffer) {
	DWORD size, sz;
	size = (DWORD)strlen(buffer)+1;
	VirtualProtectEx(pi.hProcess,(LPVOID)addr, size, PAGE_EXECUTE_READWRITE, &sz);
	WriteProcessMemory(pi.hProcess,(LPVOID)addr,(LPVOID)buffer, size, &sz);
}

void write_block(DWORD addr, PSTR buffer, DWORD size) {
	DWORD sz;
	VirtualProtectEx(pi.hProcess,(LPVOID)addr, size, PAGE_EXECUTE_READWRITE, &sz);
	WriteProcessMemory(pi.hProcess,(LPVOID)addr,(LPVOID)buffer, size, &sz);
}

LPVOID allocate_memory(DWORD size) {
	return VirtualAllocEx(
    pi.hProcess,
    NULL,
    (size_t)size,
    MEM_COMMIT,
    PAGE_EXECUTE_READWRITE
  );
}

DWORD read_file(char **buffer, const char *filename) {
	FILE *fp;
	long size;
	fp = fopen(filename, "rb");
	if(!fp) {
		MessageBoxA(0, "Error: failed to open file!", filename, MB_OK);
		exit(0);
	}

	fseek(fp, 0, SEEK_END);
	size = ftell(fp);
	fseek(fp, 0, SEEK_SET);

	*buffer = (char*)malloc(size + 1);
	fread(*buffer, 1, size, fp);
	fclose(fp);
	*(*buffer+size) = 0;
	return size+1;
}

void read_uri() {
	UINT i, max;
//only need first line
	max = read_file(&uri, "uri.dat");
	for ( i = 0; i < max; i++ )
		if ( uri[i] == '\r' || uri[i] == '\n' ) {
			uri[i] = 0;
			break;
		}
}

void read_script() {
//Replace "\n" with '\r', '\n'; and replace '\n' with 0
	script_size = read_file(&script, "script.dat");
	for ( DWORD i = 0; i < script_size; i++ )
		if ( script[i] == '\r' && script[i+1] == '\n' ) {
			script[i++] = 0; script[i] = 0;
		} else if ( script[i] == '\\' ) {
			if ( script[i + 1] == 'n' ) {
				script[i] = '\r';
				script[++i] = '\n';
			} else if ( script[i + 1] == 'r' ) {
				script[i] = ' ';
				script[++i] = '\r';
			}
		} else if( script[i] == '\n' )
			script[i] = 0;
}

int __stdcall WinMain(HINSTANCE, HINSTANCE, LPSTR, int) {
  read_uri();
  read_script();

  memset(&si, 0, sizeof si);
  memset(&pi, 0, sizeof pi);
  si.cb = sizeof si;

  if (CreateProcessA(
    "ShirenV2.exe",
    "",
    NULL,
    NULL,
    FALSE,
    DEBUG_PROCESS,
    NULL,
    NULL,
    &si,
    &pi
  ) == FALSE) {
    MessageBoxA(0, "Error: failed to open ShirenV2.exe!", "Error", MB_OK);
    return 0;
  }

  while(true) {
  DEBUG_EVENT event;
    WaitForDebugEvent(&event, INFINITE);

    switch(event.dwDebugEventCode) {

    case CREATE_PROCESS_DEBUG_EVENT: {
      apply_patches();
    } break;

    case EXIT_PROCESS_DEBUG_EVENT: {
      goto exit;
    } break;

    }

    ContinueDebugEvent(event.dwProcessId, event.dwThreadId, DBG_CONTINUE);
  }

exit:
  CloseHandle(pi.hProcess);
  CloseHandle(pi.hThread);
  free(script);
  free(uri);
  return 0;
}
